// LICENSE : MIT
"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _AssertGenerator = require('./AssertGenerator');

var _AssertGenerator2 = _interopRequireDefault(_AssertGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var esprima = require('esprima');
var estraverse = require('estraverse');
var escodegen = require("escodegen");
var doctrine = require('doctrine');

var Attachment = function () {
    function Attachment() {
        _classCallCheck(this, Attachment);
    }

    _createClass(Attachment, null, [{
        key: 'FunctionDeclaration',


        /**
         * FunctionDeclaration to FunctionDeclaration
         * This is mutable function.
         * @param node
         * @param comment
         * @returns {Object}
         */
        value: function FunctionDeclaration(node, comment) {
            /*
             TODO: sloppy is not support
             It mean that optional param just ignored.
             */
            var commentData = doctrine.parse(comment.value, { unwrap: true });
            var assertsAST = _AssertGenerator2.default.createAsserts(commentData);
            var body = node.body.body;
            body.unshift.apply(body, _toConsumableArray(assertsAST));
            return node;
        }

        /**
         * @param {Array<Object>} comment
         * @returns {string}
         */

    }, {
        key: 'FunctionDeclarationString',
        value: function FunctionDeclarationString(comment) {
            var commentData = doctrine.parse(comment.value, { unwrap: true });
            var assertsAST = _AssertGenerator2.default.createAsserts(commentData);
            return escodegen.generate({
                type: esprima.Syntax.Program,
                body: assertsAST
            });
        }

        /**
         * AST to AST
         * mutable function
         * @param {Object} AST
         * @returns {Object}
         */

    }, {
        key: 'toASTFromAST',
        value: function toASTFromAST(AST) {
            var replaceWalk = function replaceWalk(node) {
                switch (node.type) {
                    case esprima.Syntax.FunctionDeclaration:
                        if (node.leadingComments && node.leadingComments.length === 1) {
                            var comment = node.leadingComments[0];
                            if (comment.type === 'Block') {
                                return Attachment.FunctionDeclaration(node, comment);
                            }
                        }
                        break;
                    default:
                        break;
                }
            };
            return estraverse.replace(AST, {
                enter: function enter(node) {
                    var r = replaceWalk(node);
                    if (r) {
                        return r;
                    }
                }
            });
        }

        /**
         * Code to AST
         * @param {string} content
         */

    }, {
        key: 'toASTFromCode',
        value: function toASTFromCode(content) {
            var tree = esprima.parse(content.toString(), { attachComment: true, loc: true });
            return Attachment.toASTFromAST(tree);
        }
    }]);

    return Attachment;
}();

exports.default = Attachment;
module.exports = exports['default'];
//# sourceMappingURL=Attachment.js.map